Subject: bug#66846: closed (Re: 30.0.50; unexpected behavior of icon with non-existing image file?)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 06 Jan 2024 11:29:02 +0000

Your bug report

#66846: 30.0.50; unexpected behavior of icon with non-existing image file?

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
66846: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=66846
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: 30.0.50; unexpected behavior of icon with non-existing image file?
From: Eli Zaretskii <[email-masked]>
To: David Ponce <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Sat, 06 Jan 2024 13:28:04 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> Date: Fri, 5 Jan 2024 18:45:07 +0100
> From: David Ponce <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>, Stefan Kangas <[email-masked]>
> 
> Hello,
> 
> I was wondering if you had a chance to view this bug report?

Thanks, I fixed the bug on the emacs-29 branch in a slightly different
way, and I'm therefore closing this bug.

Subject: 30.0.50; unexpected behavior of icon with non-existing image file?
From: David Ponce <[email-masked]>
To: [email-masked]
Date: Tue, 31 Oct 2023 13:29:43 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

I found a possible unexpected behavior with image in icon spec.
Here are 2 small recipes that illustrate this.  In both cases the image
doesn't exist and maybe `icon-string' should return the text value of
the icon, instead of failing like illustrated below (emacs -Q):

;; TEST 1 with relative file name.
;; Raise a wrong-type-argument error instead of inserting the text
;; "test".
(define-icon test nil
'((image "does-not-exist.svg")
   (text "test"))
  "Test icon."
  :version "30")

(insert (icon-string 'test))
Debugger entered--Lisp error: (wrong-type-argument stringp nil)
   string-match("\\.png\\'" nil nil t)
   image-supported-file-p(nil)
   ...

;; TEST 2 with absolute file name.
;; Insert an invalid image instead of the text "test".
(define-icon test1 nil
   '((image "/does-not-exist.svg")
     (text "test"))
   "Test1 icon."
   :version "30")
((button custom-icon) (test1 custom-icon))
(insert (icon-string 'test1))
  nil

Please find a possible fix in the below patch to icons.el:

diff --git a/lisp/emacs-lisp/icons.el b/lisp/emacs-lisp/icons.el
index 9a6d26243c7..dec8eaa9fac 100644
--- a/lisp/emacs-lisp/icons.el
+++ b/lisp/emacs-lisp/icons.el
@@ -188,10 +188,11 @@ icons--merge-spec
  
  (cl-defmethod icons--create ((_type (eql 'image)) icon keywords)
    (let ((file (if (file-name-absolute-p icon)
-                  icon
+                  (and (file-readable-p icon) icon)
                  (and (fboundp 'image-search-load-path)
                       (image-search-load-path icon)))))
-    (and (display-images-p)
+    (and file
+         (display-images-p)
           (fboundp 'image-supported-file-p)
           (image-supported-file-p file)
           (propertize

In GNU Emacs 30.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version
  3.24.38, cairo version 1.17.8)
Repository revision: ecc8870981ef1a802f9504b1d0f261d19ab372b1
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12014000
System Description: Fedora Linux 38 (KDE Plasma)

Configured using:
  'configure PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/lib/pkgconfig'

Configured features:
ACL CAIRO DBUS FREETYPE GIF GLIB GMP GNUTLS GPM GSETTINGS HARFBUZZ JPEG
JSON LCMS2 LIBOTF LIBSELINUX LIBSYSTEMD LIBXML2 M17N_FLT MODULES NOTIFY
INOTIFY PDUMPER PNG RSVG SECCOMP SOUND SQLITE3 THREADS TIFF
TOOLKIT_SCROLL_BARS TREE_SITTER WEBP X11 XDBE XIM XINPUT2 XPM GTK3 ZLIB

Important settings:
   value of $LC_TIME: fr_FR.utf8
   value of $LANG: fr_FR.UTF-8
   locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
   tooltip-mode: t
   global-eldoc-mode: t
   eldoc-mode: t
   show-paren-mode: t
   electric-indent-mode: t
   mouse-wheel-mode: t
   tool-bar-mode: t
   menu-bar-mode: t
   file-name-shadow-mode: t
   global-font-lock-mode: t
   font-lock-mode: t
   blink-cursor-mode: t
   minibuffer-regexp-mode: t
   line-number-mode: t
   indent-tabs-mode: t
   transient-mark-mode: t
   auto-composition-mode: t
   auto-encryption-mode: t
   auto-compression-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message mailcap yank-media puny dired
dired-loaddefs rfc822 mml mml-sec password-cache epa derived epg rfc6068
epg-config gnus-util text-property-search time-date subr-x mm-decode
mm-bodies mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader
cl-loaddefs cl-lib sendmail rfc2047 rfc2045 ietf-drums mm-util
mail-prsvr mail-utils rmc iso-transl tooltip cconv eldoc paren electric
uniquify ediff-hook vc-hooks lisp-float-type elisp-mode mwheel
term/x-win x-win term/common-win x-dnd touch-screen tool-bar dnd fontset
image regexp-opt fringe tabulated-list replace newcomment text-mode
lisp-mode prog-mode register page tab-bar menu-bar rfn-eshadow isearch
easymenu timer select scroll-bar mouse jit-lock font-lock syntax
font-core term/tty-colors frame minibuffer nadvice seq simple cl-generic
indonesian philippine cham georgian utf-8-lang misc-lang vietnamese
tibetan thai tai-viet lao korean japanese eucjp-ms cp51932 hebrew greek
romanian slovak czech european ethiopic indian cyrillic chinese
composite emoji-zwj charscript charprop case-table epa-hook
jka-cmpr-hook help abbrev obarray oclosure cl-preloaded button loaddefs
theme-loaddefs faces cus-face macroexp files window text-properties
overlay sha1 md5 base64 format env code-pages mule custom widget keymap
hashtable-print-readable backquote threads dbusbind inotify lcms2
dynamic-setting system-font-setting font-render-setting cairo gtk
x-toolkit xinput2 x multi-tty move-toolbar make-network-process emacs)

Memory information:
((conses 16 37932 10514) (symbols 48 5212 0) (strings 32 13264 1275)
  (string-bytes 1 378221) (vectors 16 10360)
  (vector-slots 8 157502 10085) (floats 8 38 21) (intervals 56 220 0)
  (buffers 992 10))